const OFF = 0;
const WARNING = 1;
const ERROR = 2;

module.exports = {
    parser: 'babel-eslint',

    parserOptions: {
        ecmaVersion: 9,
        sourceType: 'module',
        ecmaFeatures: {
            jsx: true
        },
    },

    extends: [
        'eslint:recommended',
        'plugin:import/errors',
        'plugin:jsx-a11y/recommended',
        'plugin:react/recommended',
        'plugin:unicorn/recommended'

    ],

    plugins: [
        'import',
        'jsx-a11y',
        'react',
        'unicorn'
    ],

    env: {
        jest: true,
        jasmine: true,
        browser: true,
        node: true
    },

    settings: {
        react: {
            version: 'detect'
        }
    },

    rules: {
        // !!!FB!!!
        // Possible Errors (http://eslint.org/docs/rules/#possible-errors)
        'no-control-regex': WARNING,
        'no-debugger': ERROR,
        'no-dupe-args': ERROR,
        'no-dupe-keys': ERROR,
        'no-duplicate-case': WARNING,
        'no-empty': [1, {allowEmptyCatch: true}],
        'no-empty-character-class': WARNING,
        'no-ex-assign': WARNING,
        'no-extra-boolean-cast': WARNING,
        'no-extra-parens': OFF,
        'no-extra-semi': WARNING,
        'no-func-assign': ERROR,
        'no-invalid-regexp': WARNING,
        'no-irregular-whitespace': WARNING,
        'no-obj-calls': ERROR,
        'no-prototype-builtins': OFF,
        'no-regex-spaces': WARNING,
        'no-sparse-arrays': ERROR,
        'no-template-curly-in-string': OFF,
        'no-unexpected-multiline': WARNING,
        'no-unreachable': ERROR,
        'no-unsafe-finally': WARNING,
        'no-unsafe-negation': ERROR,
        'use-isnan': ERROR,
        'valid-jsdoc': OFF,
        'valid-typeof': ERROR,

        // Best Practices (http://eslint.org/docs/rules/#best-practices)
        'block-scoped-var': OFF,
        'class-methods-use-this': OFF,
        'complexity': OFF,
        'default-case': OFF,
        'guard-for-in': OFF,
        'no-caller': ERROR,
        'no-div-regex': WARNING,
        'no-else-return': OFF,
        'no-empty-function': OFF,
        'no-empty-pattern': WARNING,
        'no-eq-null': OFF,
        'no-eval': ERROR,
        'no-extend-native': WARNING,
        'no-extra-bind': WARNING,
        'no-extra-label': WARNING,
        'no-fallthrough': WARNING,
        'no-floating-decimal': ERROR,
        'no-global-assign': [2, {exceptions: ['Map', 'Set']}],
        'no-implicit-coercion': OFF,
        'no-implicit-globals': OFF,
        'no-implied-eval': ERROR,
        'no-invalid-this': OFF,
        'no-iterator': WARNING,
        'no-labels': [2, {allowLoop: true, allowSwitch: true}],
        'no-lone-blocks': WARNING,
        'no-loop-func': OFF,
        'no-magic-numbers': OFF,
        'no-multi-str': ERROR,
        'no-new-func': ERROR,
        'no-new-wrappers': WARNING,
        'no-new': WARNING,
        'no-octal': WARNING,
        'no-octal-escape': WARNING,
        'no-proto': ERROR,
        'no-redeclare': [1, {builtinGlobals: true}],
        'no-restricted-properties': OFF,
        'no-return-await': OFF,
        'no-script-url': ERROR,
        'no-self-assign': WARNING,
        'no-self-compare': WARNING,
        'no-sequences': WARNING,
        'no-throw-literal': WARNING,
        'no-unmodified-loop-condition': OFF,
        'no-unused-labels': WARNING,
        'no-useless-call': WARNING,
        'no-useless-concat': WARNING,
        'no-useless-return': WARNING,
        'no-with': WARNING,
        'require-await': WARNING,
        'vars-on-top': OFF,
        'wrap-iife': [1, 'inside'],
        'yoda': WARNING,

        // Variables (http://eslint.org/docs/rules/#variables)
        'init-declarations': OFF,
        'no-catch-shadow': ERROR,
        'no-delete-var': ERROR,
        'no-label-var': WARNING,
        'no-restricted-globals': OFF,
        'no-shadow-restricted-names': WARNING,
        'no-undef-init': OFF,
        'no-undef': ERROR,
        'no-undefined': OFF,
        'no-use-before-define': OFF,

        // Node.js and CommonJS (http://eslint.org/docs/rules/#nodejs-and-commonjs)
        'callback-return': OFF,
        'global-require': OFF,
        'handle-callback-err': WARNING,
        'no-mixed-requires': OFF,
        'no-new-require': WARNING,
        'no-path-concat': WARNING,
        'no-process-env': OFF,
        'no-process-exit': OFF,
        'no-restricted-modules': OFF,
        'no-sync': OFF,

        // Stylistic Issues (http://eslint.org/docs/rules/#stylistic-issues)
        'array-bracket-spacing': WARNING,
        'block-spacing': WARNING,
        'capitalized-comments': OFF,
        'comma-spacing': WARNING,
        'comma-style': WARNING,
        'computed-property-spacing': WARNING,
        'consistent-this': OFF,
        'func-call-spacing': WARNING,
        'func-name-matching': OFF,
        'func-names': OFF,
        'func-style': OFF,
        'id-blacklist': OFF,
        'id-length': OFF,
        'id-match': OFF,
        'key-spacing': [1, {beforeColon: false, afterColon: true}],
        'line-comment-position': OFF,
        'lines-around-comment': OFF,
        'lines-around-directive': OFF,
        'max-depth': OFF,
        'max-lines': OFF,
        'max-nested-callbacks': OFF,
        'max-statements': OFF,
        'max-statements-per-line': OFF,
        'multiline-ternary': OFF,
        'new-cap': OFF,
        'new-parens': ERROR,
        'newline-after-var': OFF,
        'newline-before-return': OFF,
        'newline-per-chained-call': OFF,
        'no-array-constructor': WARNING,
        'no-continue': OFF,
        'no-inline-comments': OFF,
        'no-lonely-if': OFF,
        'no-mixed-operators': OFF,
        'no-mixed-spaces-and-tabs': ERROR,
        'no-negated-condition': OFF,
        'no-new-object': WARNING,
        'no-plusplus': OFF,
        'no-tabs': ERROR,
        'no-ternary': OFF,
        'no-trailing-spaces': WARNING,
        'no-underscore-dangle': OFF,
        'no-unneeded-ternary': WARNING,
        'no-whitespace-before-property': WARNING,
        'object-curly-newline': OFF,
        'object-curly-spacing': WARNING,
        'object-property-newline': OFF,
        'one-var-declaration-per-line': OFF,
        'one-var': [1, {initialized: 'never'}],
        'operator-assignment': WARNING,
        'operator-linebreak': OFF,
        'padded-blocks': OFF,
        'require-jsdoc': OFF,
        'semi-spacing': WARNING,
        'semi': WARNING,
        'sort-keys': OFF,
        'sort-vars': OFF,
        'space-infix-ops': [1, {int32Hint: true}],
        'unicode-bom': [1, 'never'],
        'wrap-regex': OFF,

        // ECMAScript 6 (http://eslint.org/docs/rules/#ecmascript-6)
        'arrow-body-style': OFF,
        'arrow-spacing': WARNING,
        'constructor-super': ERROR,
        'generator-star-spacing': WARNING,
        'no-class-assign': WARNING,
        'no-const-assign': ERROR,
        'no-dupe-class-members': ERROR,
        'no-new-symbol': WARNING,
        'no-restricted-imports': OFF,
        'no-this-before-super': ERROR,
        'no-useless-computed-key': WARNING,
        'no-useless-rename': WARNING,
        'prefer-arrow-callback': [1, {allowNamedFunctions: true}],
        'prefer-numeric-literals': OFF,
        'prefer-spread': WARNING,
        'prefer-template': OFF,
        'require-yield': OFF,
        'rest-spread-spacing': WARNING,
        'sort-imports': OFF,
        'symbol-description': WARNING,
        'template-curly-spacing': WARNING,
        'yield-star-spacing': WARNING,

        // React (https://github.com/yannickcr/eslint-plugin-react)
        'react/forbid-component-props': OFF,
        'react/forbid-prop-types': OFF,
        'react/no-children-prop': OFF,
        'react/no-danger-with-children': OFF,
        'react/no-deprecated': WARNING,
        'react/no-direct-mutation-state': WARNING,
        'react/no-render-return-value': OFF,
        'react/no-set-state': OFF,
        'react/no-string-refs': OFF,
        'react/no-unescaped-entities': OFF,
        'react/no-unused-prop-types': OFF,
        'react/prefer-stateless-function': OFF,
        'react/require-optimization': OFF,
        'react/require-render-return': OFF,
        'react/sort-prop-types': OFF,
        'react/style-prop-object': OFF,
        'react/jsx-equals-spacing': [1, 'never'],
        'react/jsx-filename-extension': OFF,
        'react/jsx-first-prop-new-line': OFF,
        'react/jsx-handler-names': OFF,
        'react/jsx-max-props-per-line': OFF,
        'react/jsx-no-bind': OFF,
        'react/jsx-no-comment-textnodes': WARNING,
        'react/jsx-no-duplicate-props': ERROR,
        'react/jsx-no-literals': OFF,
        'react/jsx-no-target-blank': OFF,


        // !!!PB!!!
        'accessor-pairs': OFF,
        'array-callback-return': OFF, // TEMPORARY
        'brace-style': [ERROR, '1tbs'],
        'camelcase': OFF,
        'comma-dangle': [ERROR, 'never'],
        'consistent-return': ERROR,
        'dot-location': [ERROR, 'property'],
        'dot-notation': ERROR,
        'eol-last': ERROR,
        'eqeqeq': [ERROR, 'allow-null'],
        'indent': [ERROR, 4, {SwitchCase: 1}],
        'jsx-quotes': [ERROR, 'prefer-double'],
        'max-len': [
            ERROR, {
                code: 120,
                ignorePattern: '(?:^import )|(?:it|describe)\\(\'[\\w\\s]+\''
            }
        ],
        'max-params': [ERROR, 4],
        'no-bitwise': OFF,
        'no-case-declarations': OFF, // TEMPORARY
        'no-duplicate-imports': OFF,
        'no-inner-declarations': [ERROR, 'functions'],
        'no-multi-spaces': ERROR,
        'no-nested-ternary': ERROR,
        'no-param-reassign': OFF, // TEMPORARY
        'no-restricted-syntax': [ERROR, 'WithStatement'],
        'no-return-assign': OFF,
        'no-shadow': ERROR,
        'no-unused-expressions': [ERROR, {'allowShortCircuit': true}],
        'no-unused-vars': [ERROR, {args: 'none'}],
        'no-useless-escape': ERROR,
        'no-warning-comments': OFF, // TEMPORARY
        'prefer-const': ERROR,
        'prefer-rest-params': ERROR,
        'quotes': [ERROR, 'single', 'avoid-escape'],
        'keyword-spacing': ERROR,
        'space-before-blocks': ERROR,
        'space-before-function-paren': [ERROR, {anonymous: 'always', named: 'never'}],
        'strict': [ERROR, 'global'],
        'radix': OFF,
        'no-console': ERROR,
        'object-shorthand': [ERROR, 'always'],
        'linebreak-style': OFF,
        'no-cond-assign': OFF,
        'no-constant-condition': ERROR,
        'no-alert': ERROR,
        'no-void': ERROR,
        'quote-props': [ERROR, 'consistent-as-needed'],
        'space-unary-ops': ERROR,
        'spaced-comment': ERROR,
        'no-var': ERROR,
        'space-in-parens': ERROR,
        'arrow-parens': [1, 'as-needed'],
        'no-confusing-arrow': ERROR,
        'no-useless-constructor': ERROR,
        'curly': ERROR,
        'no-multiple-empty-lines': ERROR,

        // React & JSX
        // Our transforms set this automatically
        'react/display-name': OFF,
        'react/jsx-boolean-value': [ERROR, 'always'],
        'react/jsx-no-undef': ERROR,
        // We don't care to do this
        'react/jsx-sort-prop-types': OFF,
        'react/jsx-sort-props': OFF,
        'react/jsx-uses-react': ERROR,
        'react/jsx-uses-vars': ERROR,
        // It's easier to test some things this way
        'react/no-did-mount-set-state': OFF,
        'react/no-did-update-set-state': OFF,
        // We define multiple components in test files
        'react/no-multi-comp': OFF,
        'react/no-unknown-property': OFF,
        // This isn't useful in our test code
        'react/prop-types': OFF,
        'react/react-in-jsx-scope': ERROR,
        'react/self-closing-comp': ERROR,
        // We don't care to do this
        'react/sort-comp': [ERROR, {
            order: [
                'instance-variables',
                'static-methods',
                'everything-else',
                'lifecycle',
                'render'
            ]
        }],
        'react/jsx-closing-bracket-location': ERROR,
        'react/prefer-es6-class': ERROR,
        'react/jsx-pascal-case': ERROR,
        'react/jsx-curly-spacing': ERROR,
        'react/no-is-mounted': ERROR,
        'react/jsx-wrap-multilines': [ERROR, {declaration: false, assignment: false}],
        'react/no-array-index-key': WARNING,
        'react/no-danger': ERROR,
        'react/jsx-indent': [OFF, 4], // Seems to be overwritten by indent rule
        'react/jsx-indent-props': [OFF, 4], // Seems to be overwritten by indent rule
        'react/jsx-tag-spacing': OFF,
        'react/jsx-space-before-closing': OFF,
        'react/jsx-key': ERROR,
        'react/no-find-dom-node': ERROR,

        'import/no-duplicates': ERROR,
        'import/newline-after-import': ERROR,

        // !!!CUSTOM!!!
        'jsx-a11y/anchor-is-valid': OFF,
        'jsx-a11y/click-events-have-key-events': OFF,
        'jsx-a11y/no-onchange': OFF,
        'import/no-unresolved': OFF,
        // 2 пробела вместо 4
        'indent': [ERROR, 2, { SwitchCase: 1 }]
    }
};